pass
import pickle
class Liste:
  def __init__(self):
    self.Anzahl = 0
    self.Datenstruktur_Liste = []
  def anfuegen_Element(self, Element):
    self.Datenstruktur_Liste.append(Element)
    self.Anzahl = self.Anzahl + 1
  def schreibe_in_Datei(self):
    Dateiname = raw_input("Dateiname? ")
    Dateiobjekt = open("\\_" + Dateiname, 'w')
    pickle.dump(self.Anzahl, Dateiobjekt)
    for Element in self.Datenstruktur_Liste:
      pickle.dump(Element, Dateiobjekt)
    Dateiobjekt.close()
  def lies_aus_Datei(self):
    Dateiname = raw_input("Dateiname? ")
    Dateiobjekt = open("\\_" + Dateiname, 'r')
    Anzahl_der_Objekte = pickle.load(Dateiobjekt)
    for Elementzaehler in range(1, Anzahl_der_Objekte+1):
      Element = pickle.load(Dateiobjekt)
      self.anfuegen_Element(Element)
    self.Anzahl = Anzahl_der_Objekte
    Dateiobjekt.close() 
class Buecherliste(Liste):
  def ausgabe(self):
    print("In der Bcherliste befinden sich folgende Bcher: ")
    Lauf = 1  # Initialisierung
    for Buch in self.Datenstruktur_Liste:
      print "\n"
      print "Angaben zum %i. Buch: " % Lauf
      Buch.ausgabe()
      Lauf = Lauf + 1
  def finde_Buch_nach_Titel(self, Titel):
    Gesuchtes_Buch = None  # Initialisierung
    for Buchobjekt in self.Datenstruktur_Liste:
      if Titel == Buchobjekt.lies_Titel():
        Gesuchtes_Buch = Buchobjekt
      else:
        pass
    return Gesuchtes_Buch

class Buch:
  def __init__(self):
    self.Signatur = None
    self.Autor = None
    self.Titel = None
    self.Jahr = None
    self.Rueckgabe = None
  def eingabe(self, Buchnummer):
    self.Signatur = raw_input("Bitte geben Sie die %i. Signatur ein: " % Buchnummer)
    self.Autor = raw_input("Bitte geben Sie den %i. Autor an: " % Buchnummer)
    self.Titel = raw_input("Bitte geben Sie den %i. Titel an: " % Buchnummer)
    self.Jahr = raw_input("Bitte geben Sie das %i. Erscheinungsjahr an: " % Buchnummer)
  def ausgabe(self):
    print "Signatur: ", self.Signatur 
    print "Autor: ", self.Autor 
    print "Titel: ", self.Titel 
    print "Erscheinungsjahr: ", self.Jahr
    print "Rckgabedatum: ", self.Rueckgabe
  def setze_Rueckgabe(self, neues_Datum):
    self.Rueckgabe = neues_Datum
  def lies_Rueckgabe(self):
    return self.Rueckgabe

  def lies_Titel(self):
    return self.Titel

class Ausleihvorgangsliste(Liste):
  def erzeuge_Ausleihliste_nach_Leser(self, Aktueller_Leser):
    Buecher_des_Lesers =[]
    for Eintrag in self.Datenstruktur_Liste:
      if Eintrag.lies_Leser().lies_Bib_Karte() == Aktueller_Leser.lies_Bib_Karte():
        Buecher_des_Lesers.append(Eintrag.lies_Buch())
      else:
        pass
    return Buecher_des_Lesers

class Ausleihvorgang:
  def __init__(self, neuer_Leser, neues_Buch):
    self.AV_Leser = neuer_Leser
    self.AV_Buch = neues_Buch
  def lies_Leser(self):
    return self.AV_Leser

  def lies_Buch(self):
    return self.AV_Buch

class Ausleihliste(Liste):
  def __init__(self):
    Liste.__init__(self)   # Aufruf des Konstruktors der Klasse Liste, von der geerbt wird
    self.Ausl_Ausleihvorgangsliste = None
  def setze_Ausleihvorgangsliste(self, Aktuelle_Ausleihvorgangsliste):
    self.Ausl_Ausleihvorgangsliste = Aktuelle_Ausleihvorgangsliste
  def aktualisiere(self, Aktueller_Leser):
    Geholte_Liste = self.Ausl_Ausleihvorgangsliste.erzeuge_Ausleihliste_nach_Leser(Aktueller_Leser)
    for Buchobjekt in Geholte_Liste:
      self.anfuegen_Element(Buchobjekt)
class Leserliste(Liste):
  def ausgabe(self):
    print("In der Leserliste befinden sich folgende Leser: ")
    Lauf = 1
    for Leserobjekt in self.Datenstruktur_Liste:
      print "\n"
      print "Angaben zum %i. Leser: " % Lauf
      Leserobjekt.ausgabe()
      Lauf = Lauf + 1
  def finde_Leser_nach_Bib_Karte(self, Bib_Karte):
    # Die Funktion liefert den gesuchten Leser als Rckgabewert
    # oder None, wenn dieses nicht vorhanden ist
    Gesuchter_Leser = None   # Initialisierung  
    # Zyklus ber Leserliste
    for Leserobjekt in self.Datenstruktur_Liste:
      if Bib_Karte == Leserobjekt.lies_Bib_Karte():
        Gesuchter_Leser = Leserobjekt
      else:
        pass
    return Gesuchter_Leser

class Leser:
  def __init__(self):
    self.Bib_Karte = None
    self.Name = None
    self.Geb_Datum = None
    self.Adresse = None
    self.Leser_Ausleihliste = Ausleihliste()
  def eingabe(self, Lesernummer):
    self.Bib_Karte = raw_input("Nummer der Bibliothekskarte des %i. Lesers: " % Lesernummer)
    self.Name = raw_input("Bitte geben Sie den Namen des %i. Lesers an: " % Lesernummer)
    self.Geb_Datum = raw_input("Bitte geben Sie das Geburtsdatum des %i. Lesers an: " % Lesernummer)
    self.Adresse = raw_input("Bitte geben Sie die Adresse des %i. Lesers an: " % Lesernummer)
  def ausgabe(self):
    print "Nummer der Bibliothekskarte: ", self.Bib_Karte 
    print "Name: ", self.Name 
    print "Geburtsdatum: ", self.Geb_Datum
    print "Adresse: ", self.Adresse
  def lies_Bib_Karte(self):
    return self.Bib_Karte

  def lies_Name(self):
    return self.Name

  def lies_Ausleihliste(self):
    return self.Leser_Ausleihliste

class Bibliotheksverwaltung:
  def __init__(self):
    self.Bib_Buecherliste = Buecherliste()
    self.Bib_Leserliste = Leserliste()
    self.Bib_Ausleihvorgangsliste = Ausleihvorgangsliste()
  def buecher_ausleihen(self):
    Ausleihwunsch = "j"
    while Ausleihwunsch =="j":
      Bib_Kartennummer = raw_input("Bibliothekskartenr.? ")
      Gesuchter_Leser = self.Bib_Leserliste.finde_Leser_nach_Bib_Karte(Bib_Kartennummer)
      if Gesuchter_Leser == None:
        print "Leser nicht angemeldet"
      else:
        Ausleihwunsch_fuer_Leser = "j"  # Anfangswert setzen
        Aktualisierung_der_Ausleihliste_notwendig = "n" 
        while Ausleihwunsch_fuer_Leser == "j":
          print "Ausleihe fr", Gesuchter_Leser.lies_Name()
          Titel = raw_input("Titel des Buches? ")
          Gesuchtes_Buch = self.Bib_Buecherliste.finde_Buch_nach_Titel(Titel)
          if Gesuchtes_Buch == None:
            print "Buch nicht vorhanden"
          else:
            if Gesuchtes_Buch.lies_Rueckgabe() == None:
              Rueckgabedatum = raw_input("Rckgabedatum? ")
              # Start eines Moduls
              Gesuchtes_Buch.setze_Rueckgabe(Rueckgabedatum)
              Bib_Ausleihvorgang = Ausleihvorgang(Gesuchter_Leser, Gesuchtes_Buch)
              # Start eines Moduls
              self.Bib_Ausleihvorgangsliste.anfuegen_Element(Bib_Ausleihvorgang)
              Aktualisierung_der_Ausleihliste_notwendig = "j"
              print "Ausleihe erfolgreich"
              print "Leser:", Gesuchter_Leser.lies_Name()
              print "Buch:", Titel,
              print "Rckgabe:", Rueckgabedatum
            else:
              print "Buch ausgeliehen"
              print "bis ", Gesuchtes_Buch.lies_Rueckgabe()
              
          Ausleihwunsch_fuer_Leser = raw_input("Fr " + Gesuchter_Leser.lies_Name() + " weitere Bcher ausleihen? (j/n)")
        if Aktualisierung_der_Ausleihliste_notwendig == "j":
          Bib_Ausleihliste = Gesuchter_Leser.lies_Ausleihliste()
          # Start Modul
          Bib_Ausleihliste.setze_Ausleihvorgangsliste(self.Bib_Ausleihvorgangsliste)
          # Start Modul
          Bib_Ausleihliste.aktualisiere(Gesuchter_Leser)
          # Ende der 1. Alternative
          
        else:
          pass
      Ausleihwunsch = raw_input("Fr anderen Leser Bcher ausleihen? (j/n)")
      # Ende des 1. abweisenden Zykluses
  def hauptmenue(self):
    Nutzerwunsch = None
    while Nutzerwunsch != "e":
      print "\n"
      print "********************************"
      print "**         Hauptmen          **"
      print "********************************"
      print "Ausleihe vornehmen           (a)"
      print "Leserliste bearbeiten        (l)"
      print "Bcherliste bearbeiten       (b)"
      print "Programmende                 (e)"
      Nutzerwunsch = raw_input("Bitte treffen Sie eine Auswahl: ")
      if Nutzerwunsch == "a":
        if self.Bib_Buecherliste.Anzahl == 0:
          print "Die Bcherliste wurde noch nicht geladen."
          self.Bib_Buecherliste.lies_aus_Datei()
          print "Bcherliste geladen."
        else:
          pass
        if self.Bib_Leserliste.Anzahl == 0:
          print "Die Leserliste wurde noch nicht geladen."
          self.Bib_Leserliste.lies_aus_Datei()
          print "Leserliste geladen."
        else:
          pass
        if self.Bib_Ausleihvorgangsliste.Anzahl == 0:
          print "Die Ausleihvorgangsliste wurde noch nicht geladen."
          self.Bib_Ausleihvorgangsliste.lies_aus_Datei()
          print "Ausleihvorgangsliste geladen."
        else:
          pass
        pass
      else:
        pass
      if Nutzerwunsch == "l":
        self.menue_Leserliste()
      else:
        pass
      if Nutzerwunsch == "b":
        self.menue_Buecherliste()
      else:
        pass
      if Nutzerwunsch == "e":
        Speicherwunsch = raw_input("Mchten Sie die Listen speichern? (j/n)")
        if Speicherwunsch == "j":
          self.menue_Speichern()
        else:
          pass
      else:
        pass
  def menue_Leserliste(self):
    print "\n"
    print "********************************"
    print "**     Leserlisten - Men     **"
    print "********************************"
    print "Leserliste laden            (1)"
    print "Leserliste anzeigen         (2)"
    print "Leser hinzufgen            (3)"
    print "Leserliste speichern        (4)"
    Nutzerwunsch = raw_input("Bitte treffen Sie eine Auswahl: ")
    if Nutzerwunsch == "1":
        self.Bib_Leserliste.lies_aus_Datei()
        print "Leserliste geladen."
    elif Nutzerwunsch == "2":
        self.Bib_Leserliste.ausgabe()
    elif Nutzerwunsch == "3":
        Leserzahl = input("Wieviele neue Leser mchten Sie eingeben? ")
        for Lauf in range(1, Leserzahl+1):
            self.Bib_Leser = Leser()
            self.Bib_Leser.eingabe(Lauf)
            self.Bib_Leserliste.anfuegen_Element(self.Bib_Leser)
    elif Nutzerwunsch == "4":
        self.Bib_Leserliste.schreibe_in_Datei()
        print "Leserliste gespeichert."
  def menue_Buecherliste(self):
    print "\n"
    print "********************************"
    print "**    Bcherlisten - Men     **"
    print "********************************"
    print "Bcherliste laden            (1)"
    print "Bcherliste anzeigen         (2)"
    print "Bcher hinzufgen            (3)"
    print "Bcherliste speichern        (4)"
    Nutzerwunsch = raw_input("Bitte treffen Sie eine Auswahl: ")
    if Nutzerwunsch == "1":
        self.Bib_Buecherliste.lies_aus_Datei()
        print "Bcherliste geladen."
    elif Nutzerwunsch == "2":
        self.Bib_Buecherliste.ausgabe()
    elif Nutzerwunsch == "3":
        Buecherzahl = input("Wieviele neue Bcher mchten Sie eingeben? ")
        for Lauf in range(1, Buecherzahl+1):
            self.Bib_Buch = Buch()
            self.Bib_Buch.eingabe(Lauf)
            self.Bib_Buecherliste.anfuegen_Element(self.Bib_Buch)
    elif Nutzerwunsch == "4":
        self.Bib_Buecherliste.schreibe_in_Datei()
        print "Bcherliste gespeichert."
  def menue_Speichern(self):
    pass
    pass
Bibliotheksverwaltung = Bibliotheksverwaltung()
Bibliotheksverwaltung.hauptmenue()
