"""
Modul: Editor fr Eigenschaften einer Klasse
02.03.2002, 15.10.02
i.linkweiler@gmx.de
"""

from qt import *
from Statements import *

class KlasseneditWidget(QWidget):
  "Ein QT-Widget zum Bearbeiten von Klassen"
  def __init__(self,*args):
    "Erzeuge ein Widget"
    apply(QWidget.__init__,(self,) + args)
    self.setMinimumSize(340,180)
    self.resize(340,180)
    
    self.setCaption(_('Klasse bearbeiten'))
    self.icon=QPixmap("./icons/find.xpm")
    self.setIcon(self.icon)

    self.ok = QPushButton(_("&OK"),self,"ok")
    self.ok.setGeometry(100,150,75,24)
    self.connect(self.ok,SIGNAL("clicked()"),self.slotOk)

    self.abbruch = QPushButton(_("&Abbruch"),self,"abbruch")
    self.abbruch.setGeometry(200,150,75,24)
    self.connect(self.abbruch,SIGNAL("clicked()"),self.close)

    self.t2= QLabel(_("Name der Klasse:"),self)
    self.t2.setGeometry(20,10,300,20)
    self.edit2 = QLineEdit(self)
    self.edit2.setGeometry(20,30,300,20)

    self.t1= QLabel(_("Klasse erbt von (optional):"),self)
    self.t1.setGeometry(20,60,300,20)
    self.edit = QLineEdit(self)
    self.edit.setGeometry(20,80,300,20)

    self.check=QCheckBox (_("Zusammenklappen, d.h. keine Anzeige der Methoden"),self)
    self.check.setGeometry(20,120,300,20)

    self.exitcmd=None

  def setexitcmd(self,cmd):
    " <cmd> kann aufgerufen werden, wenn Dialog mit OK beendet wurde."
    self.exitcmd=cmd

  def setitem(self,item):
    " Setze das zu bearbeitende Objekt."
    self.item=item
    self.edit.setText(item.text)
    self.edit2.setText(item.name)
    self.check.setChecked(item.is_hidden())



  def slotOk(self):
    " Da hat wohl jemand OK geklickt."

    s=self.edit.text()
    t=unicode(s)
    self.item.setText(t)

    s=self.edit2.text()
    t=unicode(s)
    self.item.setName(t)

    self.item.hidden=self.check.isChecked()

    if self.exitcmd!=None: 
      self.exitcmd()
    self.close(1)

def main():
    "Zum Test:"
    STYLE="Qt"
    item=Klasse(STYLE)

    a = QApplication(sys.argv)
    QObject.connect(a,SIGNAL('lastWindowClosed()'),a,SLOT('quit()'))
    w = KlasseneditWidget()
    a.setMainWidget(w)
    
    w.setitem(item)
    w.show()
    a.exec_loop()

if __name__=="__main__":
  def _(x): return x
  main()
  

